Ruby: pm_constant_write_node Struct Reference

Ruby 3.4.4p34 (2025-05-14 revision a38531fd3f617bf734ef7d6c595325f69985ea1d)

Data Fields
pm_constant_write_node Struct Reference

ConstantWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_t | name
| ConstantWriteNode#name.
pm_location_t | name_loc
| ConstantWriteNode#name_loc.
struct pm_node * | value
| ConstantWriteNode#value.
pm_location_t | operator_loc
| ConstantWriteNode#operator_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

ConstantWriteNode.

Represents writing to a constant.

    Foo = 1
    ^^^^^^^

Type: PM_CONSTANT_WRITE_NODE

Definition at line 3431 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_constant_write_node::base

The embedded base node.

Definition at line 3433 of file ast.h.

Referenced by pm_dump_json().

## ◆ name

pm_constant_id_t pm_constant_write_node::name

ConstantWriteNode#name.

The name of the constant.

    Foo = :bar # name `:Foo`

    XYZ = 1    # name `:XYZ`

Definition at line 3445 of file ast.h.

Referenced by pm_dump_json().

## ◆ name_loc

pm_location_t pm_constant_write_node::name_loc

ConstantWriteNode#name_loc.

The location of the constant name.

    FOO = 1
    ^^^

Definition at line 3455 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_constant_write_node::operator_loc

ConstantWriteNode#operator_loc.

The location of the `=` operator.

    FOO = :bar
        ^

Definition at line 3478 of file ast.h.

Referenced by pm_dump_json().

## ◆ value

struct pm_node* pm_constant_write_node::value

ConstantWriteNode#value.

The value to write to the constant. It can be any non-void expression.

    FOO = :bar
          ^^^^

    MyClass = Class.new
              ^^^^^^^^^

Definition at line 3468 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h